/*
 * This file is part of the LibreOffice project.
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */
#ifndef TIMER_H
#define TIMER_H
#include "time.h"
#include "Common.h"

#define ENABLE_TIMER 0

#if ENABLE_TIMER
#define WRITETIME2FILE 1
#define TIMER_FILE "./Time.txt"
#define CON_FILE "config.txt"
#endif

#if WRITETIME2FILE
#include <iostream>
#include <iomanip>
#include <fstream>
#endif

#ifdef _WIN32
#include <windows.h>
#endif

#ifdef _linux_
#include <sys/time.h>
#endif

#ifdef _WIN32
static double dqFreq;
static LARGE_INTEGER temp;
#endif

#ifdef WRITETIME2FILE
static ofstream timerFile;
#endif

typedef std::multimap<std::string, double> Time;
static Time cpustartTime, glstartTime;
static Time cpuendTime, glendTime;
static unsigned int queryID[2];

enum funcType { CPU, GPU };

class Timer
{
public :
    Timer();
    ~Timer();

    /* Timer Function */
    void initTimer();

    static int flag;
};

class TraceTime
{
public:
    TraceTime(string funcName, int funcType);
    ~TraceTime();

    string funcName;
    int funcType;
    GLuint64 startTime, stopTime;
};
#endif
